getRSessionInfo <- function(verbose=FALSE) {
    session <- sessionInfo()
    if (verbose) {
        res <- capture.output(session)
        res[-grep("^$", res)]
    } else {
        opkgs <- session$otherPkgs
        opkgs <- paste(names(opkgs), sapply(opkgs, "[", "Version"), sep="_")
        c(session$basePkgs, opkgs)
    }
}
typeInfo(getRSessionInfo, rewrite=FALSE) <-
    SimultaneousTypeSpecification(
        TypedSignature(verbose="logical"),
        returnType="character")

