package org.bioconductor.packages.rservices;

import org.omegahat.R.Java.RException;

public class MockService {
	private RServicesEnv e;

	public MockService(RServicesEnv e) throws Exception {
		this.e = e;
	}

	public boolean mockJava2R(Object javaData, String rScript, String rVariable)
			throws Exception {
		e.source(rScript);
		try {
			e.call("checkJava2R", new Object[] { javaData, rVariable });
		} catch (RException ex) {
			throw new AssertionError(ex.getMessage());
		} finally {
			e.rm(rVariable);
		}
		return true;
	}

	public Object mockR2Java(String rScript, String rVariable) throws Exception {
		e.source(rScript);
		Object realData = e.call("get", new Object[] { rVariable });
		e.rm(rVariable);
		return realData;
	}
}
