/**
 * RJComplex.java
 * 
 * This java class corresponds to R Character Vector 
 */
package org.bioconductor.packages.rservices;

import java.util.Arrays;

public class RJComplex implements java.io.Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected double[] real = new double[0];

	protected double[] imaginary = new double[0];

	public RJComplex() {
	}

	public RJComplex(double[] real, double[] imaginary) {
		this.real = real;
		this.imaginary = imaginary;
	}

	/**
	 * Sets the real for this RJComplex.
	 * 
	 * @param real
	 */
	public void setReal(double[] real) {
		this.real = real;
	}

	/**
	 * Sets the real for this RJComplex.
	 * 
	 * @param real
	 */
	public void setReal(Double real) {
		this.real = new double[] { real.doubleValue() };
	}

	/**
	 * Gets the real for this RJComplex.
	 * 
	 * @return real
	 */
	public double[] getReal() {
		return real;
	}

	/**
	 * Sets the imaginary for this RJComplex.
	 * 
	 * @param imaginary
	 */
	public void setImaginary(double[] imaginary) {
		this.imaginary = imaginary;
	}

	/**
	 * Sets the imaginary for this RJComplex.
	 * 
	 * @param imaginary
	 */
	public void setImaginary(Double imaginary) {
		this.imaginary = new double[] { imaginary.doubleValue() };
	}

	/**
	 * Gets the imaginary for this RJComplex.
	 * 
	 * @return imaginary
	 */
	public double[] getImaginary() {
		return imaginary;
	}

	public int length() {
		int res = 0;
		if (imaginary != null) {
			res = imaginary.length;
		}
		return res;
	}

	@Override
	public boolean equals(Object inputObject) {
		boolean res = getClass().equals(inputObject.getClass());
		if (res) {
			RJComplex obj = (RJComplex) inputObject;
			double[] objReal = obj.getReal();
			res = res && Arrays.equals(real, objReal);
			double[] objImaginary = obj.getImaginary();
			res = res && Arrays.equals(imaginary, objImaginary);
		}
		return res;
	}

	@Override
	public String toString() {
		StringBuffer res = new StringBuffer("RJComplex {");
		res.append(", value= ");
		if ((real == null) || (imaginary == null)) {
			res.append("null");
		} else {
			res.append("[ ");
			for (int i = 0; i < real.length; i++) {
				res.append(real[i]).append("+(").append(imaginary[i]).append(
						")i ");
			}
			res.append("]");
		}
		res.append(" }");
		return res.toString();
	}

}
