/**
 * RJComplexArray.java
 * 
 * This java class corresponds to R ComplexArray 
 */
package org.bioconductor.packages.rservices;

import java.util.Arrays;

public class RJComplexArray extends RJArray {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected RJComplex value = new RJComplex();

	public RJComplexArray() {
	}

	public RJComplexArray(RJComplex value, int[] dim, Object[] dimnames) {
		this.value = value;
		this.dim = dim;
		this.dimnames = dimnames;
	}

	/**
	 * Sets the value for this RJComplexArray.
	 * 
	 * @param value
	 */
	public void setValue(RJComplex value) {
		this.value = value;
	}

	/**
	 * Gets the value for this RJComplexArray.
	 * 
	 * @return value
	 */
	public RJComplex getValue() {
		return value;
	}

	@Override
	public boolean equals(Object inputObject) {
		boolean res = getClass().equals(inputObject.getClass());
		if (res) {
			RJComplexArray obj = (RJComplexArray) inputObject;
			int[] objDim = obj.getDim();
			RJComplex objValue = obj.getValue();
			Object[] objDimnames = obj.getDimnames();
			res = res && value.equals(objValue);
			if ((dim == null) || (objDim == null)) {
				res = res && (dim == objDim);
			} else {
				res = res && Arrays.equals(objDim, dim);
			}
			if ((dimnames == null) || (objDimnames == null)) {
				res = res && (dimnames == objDimnames);
			} else {
				res = res && Arrays.deepEquals(dimnames, objDimnames);
			}
		}
		return res;
	}

	@Override
	public String toString() {
		StringBuffer res = new StringBuffer("RJComplexArray {");
		res.append("value= " + String.valueOf(value));
		if (dim == null) {
			res.append(", dim=null");
		} else {
			res.append(", dim= " + Arrays.toString(dim));
		}
		if (dimnames == null) {
			res.append(", dimnames=null");
		} else {
			res.append(", dimnames= " + Arrays.deepToString(dimnames));
		}
		res.append(" }");
		return res.toString();
	}
}
