/**
 * RJUtil.java
 * 
 * A helper class for RJ* classes 
 */
package org.bioconductor.packages.rservices;

import java.util.*;

public class RJUtil {

	public static boolean deepEquals(HashMap x, HashMap y) {
		boolean res = true;
		if ((x == null) || (y == null)) {
			res = res && (x == y);
		} else {
			Set keys = x.keySet();
			res = res && keys.equals(y.keySet());
			Iterator i = keys.iterator();
			Object eleKey = null;
			Object eleX = null;
			Object eleY = null;
			while (res && i.hasNext()) {
				eleKey = i.next();
				eleX = x.get(eleKey);
				eleY = y.get(eleKey);
				if ((eleX == null) || (eleY == null)) {
					res = res && (eleX == eleY);
				} else {
					res = res && eleX.getClass().equals(eleY.getClass());
				}
				if (res && (eleX != null)) {
					String eleClass = eleX.getClass().getName();
					if (eleClass.equals("[Ljava.lang.Object;")) {
						res = res
								&& Arrays.deepEquals((Object[]) eleX,
										(Object[]) eleY);
					} else if (eleClass.equals("[Ljava.lang.String;")) {
						res = res
								&& Arrays.equals((String[]) eleX,
										(String[]) eleY);
					} else if (eleClass.equals("[B")) {
						res = res
								&& Arrays.equals((byte[]) eleX, (byte[]) eleY);
					} else if (eleClass.equals("[D")) {
						res = res
								&& Arrays.equals((double[]) eleX,
										(double[]) eleY);
					} else if (eleClass.equals("[I")) {
						res = res && Arrays.equals((int[]) eleX, (int[]) eleY);
					} else if (eleClass.equals("[Z")) {
						res = res
								&& Arrays.equals((boolean[]) eleX,
										(boolean[]) eleY);
					} else if (eleClass.equals("java.util.HashMap")) {
						res = res
								&& RJUtil.deepEquals((HashMap) eleX,
										(HashMap) eleY);
					} else {
						res = res && eleX.equals(eleY);
					}
				}
			}
		}
		if (!res) {
			System.err.println("HashMap x does not equal to HashMap y:");
			System.err.println("<x>");
			System.err.println(String.valueOf(x));
			System.err.println("<y>");
			System.err.println(String.valueOf(y));
		}
		return res;
	}
}
