/**
 * RRaw.java
 * 
 * This java class corresponds to R raw Vector 
 */
package org.bioconductor.packages.rservices;

import java.util.Arrays;

public class RRaw extends RVector {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected byte[] value = new byte[0];

	public RRaw() {
	}

	public RRaw(byte[] value, String[] names) {
		super(names);
		this.value = value;
	}

	/**
	 * Sets the value for this RRaw.
	 * 
	 * @param value
	 */
	public void setValue(byte[] value) {
		this.value = value;
	}

	/**
	 * Sets the value for this RRaw.
	 * 
	 * @param value
	 */
	public void setValue(Byte value) {
		this.value = new byte[] { value.byteValue() };
	}

	/**
	 * Gets the value for this RRaw.
	 * 
	 * @return value
	 */
	public byte[] getValue() {
		return value;
	}

	@Override
	public int length() {
		int res = 0;
		if (value != null) {
			res = value.length;
		}
		return res;
	}

	@Override
	public boolean equals(Object inputObject) {
		boolean res = getClass().equals(inputObject.getClass());
		if (res) {
			RRaw obj = (RRaw) inputObject;
			byte[] objValue = obj.getValue();
			res = res && Arrays.equals(value, objValue);
			String[] objNames = obj.getNames();
			res = res && Arrays.equals(names, objNames);
		}
		return res;
	}

	@Override
	public String toString() {
		StringBuffer res = new StringBuffer("RRaw {");
		res.append("value= " + Arrays.toString(value));
		res.append(", name= " + Arrays.toString(names));
		res.append(" }");
		return res.toString();
	}

}
