package org.bioconductor.packages.rservices;

import junit.framework.JUnit4TestAdapter;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

public class RFileReferencesTest extends TypeTestUtil {
	/**
	 * Used for backward compatibility (IDEs, Ant and JUnit 3.x text runner)
	 */
	public static junit.framework.Test suite() {
		return new JUnit4TestAdapter(RFileReferencesTest.class);
	}

	/**
	 * Sets up the test fixture; Called before all the tests; Called only once.
	 */
	@BeforeClass
	public static void loadCLevelConverter() throws Exception {
		e.voidEval("regAddonCvt()");
	}

	@Test
	public void testLocalRFileReferences() throws Exception {
		RFileReferences refs = new RFileReferences(new RChar(
				new String[] { "foo/bar" }), new RChar(new String[] { "baz" }),
				new RChar(new String[] { "TYPE" }));
		assertTrue(refs.equals(refs));
	}

	@Test
	public void testEmptyRFileReferencesFromR() throws Exception {
		Object res = e.eval("FileReferences()");
		RFileReferences refs = new RFileReferences();
		assertTrue(refs.equals(res));
	}

	@Test
	public void testEmptyRFileReferences() throws Exception {
		RFileReferences refs = new RFileReferences();
		Object res = reflectObj(refs);
		assertTrue(refs.equals(res));
	}

	@Test
	public void testRFileReferences() throws Exception {
		RChar urls = new RChar(new String[] { "/foo/bar", "/foo/baz" });
		RChar names = new RChar(new String[] { "bar", "baz" });
		RChar types = new RChar(new String[] { "TYPE1", "TYPE2" });
		RFileReferences refs = new RFileReferences(urls, names, types);
		Object res = reflectObj(refs);
		assertTrue(refs.equals(res));
	}
}
