setClassUnion("myUnion", c("character", "logical"))
setClass("myWrapper", representation(data="myUnion"))

###################################################
#    Java class MyWrapper to R class union

###################################################
cvtClassUnionFromJava <- function(x, thisClassName) {
    ans <- .Java(x, "getData")
    ans
}

cvtMyWrapperFromJava <- function(x, thisClassName) {
    theData <- .Java(x, "getData", .convert=FALSE)
    theData <- cvtClassUnionFromJava(theData, thisClassName)
    ans <- new("myWrapper")
    ans@data <- theData
    ans
}

matchMyWrapperFromJava <- function(x, thisClassName) {
    #cat("inside match function, df from java...", thisClassName, "\n")
    thisClassName == "testdata.MyWrapper"
}

###################################################
#    R Class Union Example to Java class My Wrapper
###################################################
cvtClassUnionToJava <- function(x, ...) {
    if (matchCharacterToJava(x))  {
        factory <- .JNew("testdata.MyUnionRCharFactory",.convert=FALSE)
    } else {
        factory <- .JNew("testdata.MyUnionRLogicalFactory", .convert=FALSE)
    }
    .Java(factory, "setData", x, .convert=FALSE)
    factory
}

cvtMyWrapperToJava <- function(x, ...) {
    #cat("inside cvtMyWrapperToJava...\n")
    data <- x@data
    data <- cvtClassUnionToJava(data)
    ans <- .JNew("testdata.MyWrapper", .convert=FALSE)
    .Java(ans, "setData", data, .convert=FALSE)
    ans
}

matchMyWrapperToJava <- function(x, ...) {
    #cat("class(x)=", class(x), "\n")
    class(x)=="myWrapper"
}

setJavaFunctionConverter (cvtMyWrapperFromJava, matchMyWrapperFromJava,
    description="Java class MyWrapper to R myWrapper",
    fromJava=TRUE, position=1)
setJavaFunctionConverter (cvtMyWrapperToJava, matchMyWrapperToJava,
    description="R Class Union Example to MyWrapper",
    fromJava=FALSE, position=1)


