/**
 * MyUnionFactory.java
 * 
 * This java class represents the union of RChar and RLogical 
 */
package testdata;
import org.bioconductor.packages.rservices.*;

public abstract class MyUnionFactory {
	public static final int RCHAR = 1;
	public static final int RLOGICAL = 2;

	public abstract void setData(RObject data) throws Exception; 
	public abstract RObject getData() ;
 
	public static MyUnionFactory getMyUnionFactory (int whichFactory){
	    switch (whichFactory) {
		case RCHAR:
		    return new MyUnionRCharFactory();
		case RLOGICAL:
		    return new MyUnionRLogicalFactory();
		default:
		    return null;
	    }
	}
}
        
