\name{FileReferences-class}
\docType{class}
\alias{FileReferences-class}

\title{Class "FileReferences"}
\description{
  FileReferences represents a collection of urls at which files can be
  referenced, the local names by which the files are to be refered to
  (to allow the file name portion of the url to differ from the name
  used to refer to the file), and the types (e.g., CEL, xls, etc.) of
  the files.
}
\section{Objects from the Class}{

  Objects can be created by calls to the constructor
  \code{\link{FileReferences}}. Objects are constructed with
  equal-length character vectors.

  Elements can be accessed with \code{\link{urls}},
  \code{\link{localNames}}, and \code{\link{types}}.

}
\section{Slots}{
  \describe{

    \item{\code{urls}:}{Object of class \code{"character"} containing
      the urls where the files can be lcoated}

    \item{\code{localNames}:}{Object of class \code{"character"}
      containing the local names by which the files will be refered.}

    \item{\code{types}:}{Object of class \code{"character"} containing
      information on the file 'type', for instance indicating that the
      files are CEL files (for gene expression analysis). Usually file
      types will be from a controlled vocabulary of types defined
      elsewhere.}

  }
}
\section{Methods}{

  See \code{\link{FileReferences}}

}

\author{Martin Morgan \url{mtmorgan@fhcrc.org}}

\seealso{

  \code{\link{FileReferences}} for object consturction, accessors
  \code{\link{urls}}, \code{\link{localNames}}, and \code{\link{types}}

}

\examples{
showClass("FileReferences")
FileReferences()
}
\keyword{classes}
