\name{generateDataMap}
\alias{generateDataMap}
\title{Create java beans and mapping functions for a R data type}
\description{
  The \code{generateDataMap} function generates java beans and R--Java data type conversions for a R data type if they are not available in the environment \code{lookup}. All java mappings are output as files under \code{CurrentWorkingDir/biocJavaMap}, where \code{CurrentWorkingDir} is the result of \code{getwd()}. This function also updates environments \code{lookup} and \code{cvtImport} (see arguments below) as a side effect.  
}
\usage{
generateDataMap(rType, javaToR, deployMode, typeMode, lookup)
}
\arguments{
  \item{rType}{a character vector containing a R data type name. The data type is either a S4 class or a ClassUnion.} 
  \item{javaToR}{logical, TRUE if want to convert Java data to R, FALSE if want to convert R data to Java.}
  \item{deployMode}{Character, either "demo" or "jms". How the service
    will be deployed. "demo" is no longer supported.}
  \item{typeMode}{Character, either "robject" or
    "javalib". How Java objects should be generated; see
    \code{\link{generateDataMap}} and \code{\link{converters}}}
  \item{lookup}{environment, key is rType, value is of type \code{RJMap}. \code{RJMap} provides the java type, java package, and java--R conversion function names for the key. By default, \code{lookup} only contains mapping information for vector, list, factor, data frame, array, matrix, environment and NULL} 
}
\value{
  returns updated environment \code{lookup}.
}
\author{Nianhua Li}
\seealso{
\code{printLookup}
}
\examples{
    ## used internally
}
\keyword{interface}
