\name{register-converters}
\alias{regAddonCvt}
\alias{regAddonCvt2}
\alias{regTestCvt}
\title{Load R - Java data converters.}

\description{
  When invoking R from Java, data type conversions between R and Java
  are handled by \code{SJava}. But \code{SJava} only supports conversions
  for limited R data types, the conversions for other R data types are
  specified by user converters and interpreted by
  \code{SJava}. \code{regAddonCvt} and \code{regTestCvt} help to load
  user converters.
}

\usage{
regAddonCvt()
regAddonCvt2()
regTestCvt()
}

\details{
  These functions are usually used by the auto-generated codes from
  \code{\link{generateFunctionMap}}. Users do not need to deal with
  them. \code{regAddonCvt} and \code{regAddonCvt2} load converters for R
  character, logical, integer, numeric, raw, complex, array, matrix,
  data.frame, list, environment, and factor. The \code{regAddonCvt}
  converters follow the \sQuote{robject} model whereas
  \code{regAddonCvt2} follows the \sQuote{javalib} model; see
  \code{\link{converters}} for more information. \code{regTestCvt} are
  used for low-level testing.
}
\author{Nianhua Li}
\keyword{interface}
